<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
session_start();

require_once ("./constants.php");
require_once (ROOT_PATH . "/lang/" . $language . "/admin.php");
require_once (ROOT_PATH . "/includes/functions.php");
require_once (ROOT_PATH . PHP_PATH . "/global.php");

if (checkPermission("admin"))
    {
    $data          =$_REQUEST;
    $imageUpload   =$_FILES;
    $data['action']=isset($data['action']) ? $data['action'] : 'admin_general';

    switch ($data['action'])
        {
        case "admin_general":
            $category_num    =$GLOBALS['categoryService']->getNum();
            $image_num       =$GLOBALS['imageService']->getNum();
            $user_num        =$GLOBALS['userService']->getNum();
            $comment_num     =$GLOBALS['commentService']->getNum();
            $lightbox_num    =$GLOBALS['lightboxService']->getNum();
            $md_size         =format_file_size($GLOBALS['categoryService']->getDirSize(ROOT_PATH . DATA_PATH));
            $result          =$GLOBALS['generalService']->getDbSize($table_prefix);
            $total_size      =format_file_size($result['total']);
            $image_size      =format_file_size($result['image']);
            $images_hits     =$GLOBALS['imageService']->searchTop("hits");
            $images_rating   =$GLOBALS['imageService']->searchTop("rating");
            $images_votes    =$GLOBALS['imageService']->searchTop("votes");
            $images_downloads=$GLOBALS['imageService']->searchTop("downloads");

            break;

        case "admin_add_image":
            $err =false;

            $flag=false;

            if (array_key_exists('save', $data))
                {
                $error=$GLOBALS['imageService']->checkAddForm($data, $imageUpload);

                if (!empty($error))
                    {
                    foreach ($error as $index => $val)
                        {
                        $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>",
                                              $lang[preg_replace('/(\d+)$/', '', $index)]);
                        }

                    $err    =true;
                    $errInfo=create_errinfo('red', $lang['add_error']);
                    }
                else
                    {
                    $flag=$GLOBALS['imageService']->save($data, $imageUpload);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['add_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['add_error']);
                        }
                    }
                }

            $data['rows_per_page']=isset($data['rows_per_page']) ? $data['rows_per_page'] : '1';

            for ($i=0; $i < intval($data['rows_per_page']); $i++)
                {
                $cats[$i] = listCategories(1, 0, isset($data['category' . $i]) ? $data['category' . $i] : "0", 0);
                $users[$i]=listUsers(isset($data['user' . $i]) ? $data['user' . $i] : "0", 0);
                }

            break;

        case "admin_search_image":
            $cats =listCategories(1, 0, "all", 1);

            $users=listUsers("0", 1);
            break;

        case "admin_list_image":
            $data['category']=isset($data['category']) ? $data['category'] : '1';

            $result          =$GLOBALS['imageService']->searchByAdmin($data);
            $navigation      =$result['nav'];
            $images          =$result['images'];
            break;

        case "admin_edit_image":
            $err =false;

            $flag=false;

            if (array_key_exists('update', $data))
                {
                $error=$GLOBALS['imageService']->checkUpdateForm($data, $imageUpload);

                if (!empty($error))
                    {
                    foreach ($error as $index => $val)
                        {
                        $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>", $lang[$index]);
                        }

                    $err    =true;
                    $errInfo=create_errinfo('red', $lang['edit_error']);
                    }
                else
                    {
                    $flag=$GLOBALS['imageService']->update($data, $imageUpload);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['edit_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['edit_error']);
                        }
                    }
                }

            $image=$GLOBALS['imageService']->searchById($data['id']);
            $cats =listCategories(1, 0, $err ? $data['category'] : $image['cat_id'], 0);
            $users=listUsers($err ? $data['user'] : $image['user_id'], 0);
            break;

        case "admin_delete_image":
            $ids=$data['deleteimages'];

            if (!is_null($ids))
                {
                $GLOBALS['imageService']->del($ids);
                }

            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_search_image");
            break;

        case "admin_add_category":
            $err =false;

            $flag=false;

            if (array_key_exists('save', $data))
                {
                $error=$GLOBALS['categoryService']->checkAddForm($data);

                if (!empty($error))
                    {
                    foreach ($error as $index => $val)
                        {
                        $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>", $lang[$index]);
                        }

                    $err    =true;
                    $errInfo=create_errinfo('red', $lang['add_error']);
                    }
                else
                    {
                    $flag=$GLOBALS['categoryService']->save($data);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['add_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['add_error']);
                        }
                    }
                }

            $data['pcategory']=isset($data['pcategory']) ? $data['pcategory'] : '1';
            $cats             =listCategories(1, 0, $data['pcategory'], 0);
            $order            =listOrder($data['pcategory']);

            break;

        case "admin_list_category":
            $catRows=listCategoryRows(1, 0);

            break;

        case "admin_edit_category":
            $err =false;

            $flag=false;

            if (array_key_exists('update', $data))
                {
                $error=$GLOBALS['categoryService']->checkUpdateForm($data);

                if (!empty($error))
                    {
                    foreach ($error as $index => $val)
                        {
                        $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>", $lang[$index]);
                        }

                    $err    =true;
                    $errInfo=create_errinfo('red', $lang['edit_error']);
                    }
                else
                    {
                    $flag=$GLOBALS['categoryService']->update($data);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['edit_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['edit_error']);
                        }
                    }
                }

            $category=$GLOBALS['categoryService']->searchById($data['id']);
            break;

        case "admin_order_category":
            $GLOBALS['categoryService']->changeOrder($data);

            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_list_category");
            break;

        case "admin_delete_category":
            $id=$data['id'];

            $GLOBALS['categoryService']->del($id);
            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_list_category");
            break;

        case "admin_add_user":
            $err =false;

            $flag=false;

            if (array_key_exists('save', $data))
                {
                $error=$GLOBALS['userService']->checkAddForm($data);

                if (!empty($error))
                    {
                    foreach ($error as $index => $val)
                        {
                        $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>",
                                              $lang[preg_replace('/(\d+)$/', '', $index)]);
                        }

                    $err    =true;
                    $errInfo=create_errinfo('red', $lang['add_error']);
                    }
                else
                    {
                    $flag=$GLOBALS['userService']->save($data);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['add_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['add_error']);
                        }
                    }
                }

            $data['num']=isset($data['num']) ? $data['num'] : '1';

            for ($i=0; $i < intval($data['num']); $i++)
                {
                $roles[$i]=listRoles(isset($data['role' . $i]) ? $data['role' . $i] : "0", 0);
                }

            break;

        case "admin_search_user":
            $roles=listRoles("0", 1);

            break;

        case "admin_list_user":
            $result    =$GLOBALS['userService']->searchByAdmin($data);

            $navigation=$result['nav'];
            $users     =$result['users'];
            break;

        case "admin_edit_user":
            $err =false;

            $flag=false;

            if (array_key_exists('update', $data))
                {
                $error=$GLOBALS['userService']->checkUpdateForm($data);

                if (!empty($error))
                    {
                    foreach ($error as $index => $val)
                        {
                        $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>", $lang[$index]);
                        }

                    $err    =true;
                    $errInfo=create_errinfo('red', $lang['edit_error']);
                    }
                else
                    {
                    $flag=$GLOBALS['userService']->update($data);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['edit_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['edit_error']);
                        }
                    }
                }

            $user =$GLOBALS['userService']->searchById($data['id']);
            $roles=listRoles($err ? $data['role'] : $user['user_role'], 0);
            break;

        case "admin_delete_user":
            $ids=$data['deleteusers'];

            if (!is_null($ids))
                {
                $GLOBALS['userService']->del($ids);
                }

            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_search_user");
            break;

        case "admin_send_email":
            $flag      =false;

            $useremails=listEmails($data['oneemail']);

            $emails    =$data['emails'];

            if (!is_null($emails))
                {
                $data['emails']=array_filter($emails);

                if (count(array_filter($data['emails'])) > 0)
                    {
                    $flag=$GLOBALS['emailService']->send($data);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['send_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['send_error']);
                        }
                    }
                }

            break;

        case "admin_search_comment": break;

        case "admin_list_comment":
            $result    =$GLOBALS['commentService']->searchByAdmin($data);

            $navigation=$result['nav'];
            $comments  =$result['comments'];
            break;

        case "admin_edit_comment":
            $err =false;

            $flag=false;

            if (array_key_exists('update', $data))
                {
                $error=$GLOBALS['commentService']->checkUpdateForm($data);

                if (!empty($error))
                    {
                    foreach ($error as $index => $val)
                        {
                        $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>", $lang[$index]);
                        }

                    $err    =true;
                    $errInfo=create_errinfo('red', $lang['edit_error']);
                    }
                else
                    {
                    $flag=$GLOBALS['commentService']->update($data);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['edit_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['edit_error']);
                        }
                    }
                }

            $comment=$GLOBALS['commentService']->searchById($data['id']);
            break;

        case "admin_delete_comment":
            $ids=$data['deletecomments'];

            if (!is_null($ids))
                {
                $GLOBALS['commentService']->del($ids);
                }

            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_search_comment");
            break;

        case "admin_search_lightbox": break;

        case "admin_list_lightbox":
            $result    =$GLOBALS['lightboxService']->searchByAdmin($data);

            $navigation=$result['nav'];
            $lightboxes=$result['lightboxes'];
            break;

        case "admin_delete_lightbox":
            $ids=$data['deletelightboxes'];

            if (!is_null($ids))
                {
                $GLOBALS['lightboxService']->del($ids);
                }

            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_search_lightbox");
            break;

        case "admin_list_keyword":
            $keywords=listKeywords();

            break;

        case "admin_delte_keyword":
            $ids=$data['keywords'];

            if (!is_null($ids))
                {
                $GLOBALS['keywordService']->del($ids);
                }

            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_list_keyword");
            break;

        case "admin_setting":
            $err =false;

            $flag=false;

            if (array_key_exists('update', $data))
                {
                $error=$GLOBALS['generalService']->checkUpdateForm($data);

                if (!empty($error))
                    {
                    foreach ($error as $index => $val)
                        {
                        $lang[$index]=sprintf("<span>%s<font size=+1 color=red>*</font></span>", $lang[$index]);
                        }

                    $err    =true;
                    $errInfo=create_errinfo('red', $lang['edit_error']);
                    }
                else
                    {
                    $flag=$GLOBALS['generalService']->update($data);

                    if ($flag)
                        {
                        $errInfo=create_errinfo('green', $lang['edit_success']);
                        }
                    else
                        {
                        $errInfo=create_errinfo('red', $lang['edit_error']);
                        }
                    }
                }

            $smtp_server  =$GLOBALS['generalService']->getValue('smtp_server');
            $smtp_port    =$GLOBALS['generalService']->getValue('smtp_port');
            $smtp_username=$GLOBALS['generalService']->getValue('smtp_username');
            $smtp_password=$GLOBALS['generalService']->getValue('smtp_password');

            break;

        case "admin_list_backup":
            $tables     =listTables($table_prefix);

            $backupfiles=$GLOBALS['generalService']->listBackupFiles();
            break;

        case "admin_make_backup":
            $tables=$data['tables'];

            if (!is_null($tables))
                {
                $GLOBALS['generalService']->makeBackupFiles($tables);
                }

            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_list_backup");
            break;

        case "admin_delete_backup":
            $file=$data['file'];

            $GLOBALS['generalService']->delBackupFiles($file);
            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_list_backup");
            break;

        case "admin_download_backup":
            $file=$data['file'];

            $GLOBALS['generalService']->downloadBackupFiles($file);
            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_list_backup");
            break;

        case "admin_show_backup":
            $file=$data['file'];

            $GLOBALS['generalService']->showBackupFiles($file);
            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_list_backup");
            break;

        default:
            header ("Location:" . ROOT_PATH . PHP_PATH . "admin.php?action=admin_general");

            break;
        }

    include_once (ROOT_PATH . TEMPLATES_PATH . "/header.htm");
    include_once (ROOT_PATH . TEMPLATES_PATH . "/admin_common.htm");
    include_once (ROOT_PATH . TEMPLATES_PATH . "/footer.htm");
    }
?>